unit uFrmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, uCountThread;

// ϸԱ 006 ʾֻĶʵһ̳߳ˡ

type
  TFrmMain = class(TForm)
    memMsg: TMemo;
    memInfo: TMemo;
    sgNums: TStringGrid;
    btnWork: TButton;
    lblProcess: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnWorkClick(Sender: TObject);
  private
    { Private declarations }

    FCountThreadArr: array of TCountThread;
    // ߳

    FCurRow: integer; // ǰ Num к
    FFininshedCount: integer;

    procedure LockCurRow;
    procedure UnlockCurRow;

    procedure LockFininshedCount;
    procedure UnlockFininshedCount;

    procedure DispProcess(ACurTaskCount: integer);

    procedure DispMsg(AMsg: string);
    procedure OnThreadMsg(AMsg: string);

    procedure OnCountAction(Sender: TCountThread; ACountAction: TCountAction);

    procedure DoOnNeedANum(Sender: TCountThread);
    procedure DoOnCountResult(Sender: TCountThread);
    procedure DoOnStop(Sender: TCountThread);

  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

{ TFrmMain }
uses
  Math;

const
  cnMaxRow = 20; // 
  cnThreadCount = 5; // ̵߳

procedure TFrmMain.btnWorkClick(Sender: TObject);
var
  i: integer;
begin

  btnWork.Enabled := false; // ʼ㣬ֹ

  // lblProcess.Caption:='';
  DispProcess(0);

  for i := 1 to cnMaxRow do
  begin
    sgNums.Cells[2, i] := '';
  end;

  FCurRow := 0;
  FFininshedCount := 0;

  for i := 0 to cnThreadCount - 1 do // ߳
  begin
    FCountThreadArr[i].AllowedCount := true;
  end;

end;

procedure TFrmMain.DispMsg(AMsg: string);
begin
  memMsg.Lines.Add(AMsg);
end;

procedure TFrmMain.DispProcess(ACurTaskCount: integer);
begin
  lblProcess.Caption := ':' + inttostr(cnMaxRow) + ',:' + inttostr(ACurTaskCount);
end;

procedure TFrmMain.DoOnCountResult(Sender: TCountThread);
begin

  // Ƕ̴߳룬Զ VCL ķҪ
  //  Sender ϱ RowԺѹ

  LockFininshedCount; // Ƕ̵߳ãҪ
  try

    inc(FFininshedCount);

    TThread.Synchronize(nil,
      procedure
      begin
        DispProcess(FFininshedCount);
        sgNums.Cells[2, Sender.Row] := inttostr(Sender.Sum);
      end);

    if FFininshedCount >= cnMaxRow then // ȫˣͻָť
    begin

      TThread.Synchronize(nil,
        procedure
        begin
          btnWork.Enabled := true;
        end);

    end;

  finally
    UnlockFininshedCount;
  end;
end;

procedure TFrmMain.DoOnNeedANum(Sender: TCountThread);
var
  sNum: string;
begin

  // ̴߳룬VCL Ӧ TThread.Synchronize 

  LockCurRow; // Ϊж߳ͬʱҪ FCurRow 
  try

    if FCurRow < cnMaxRow then
    begin
      inc(FCurRow);
      TThread.Synchronize(nil,
        procedure
        begin
          sNum := sgNums.Cells[1, FCurRow];
        end);
      Sender.Num := StrToInt(sNum);
      Sender.Row := FCurRow;
      // ߳
    end
    else
    begin
      Sender.AllowedCount := false; // ߳ͣ
    end;

  finally
    UnlockCurRow;
  end;
end;

procedure TFrmMain.DoOnStop(Sender: TCountThread);
begin
end;

procedure TFrmMain.FormCreate(Sender: TObject);
var
  i: integer;
begin

  SetLength(FCountThreadArr, cnThreadCount);

  for i := 0 to cnThreadCount - 1 do
  begin
    FCountThreadArr[i] := TCountThread.Create;
    FCountThreadArr[i].OnMsg := self.OnThreadMsg;
    FCountThreadArr[i].OnCountAction := self.OnCountAction;
  end;

  sgNums.RowCount := cnMaxRow + 1;
  sgNums.ColCount := 3;

  sgNums.Cells[0, 0] := '';
  sgNums.Cells[1, 0] := 'Num';
  sgNums.Cells[2, 0] := 'Sum';

  for i := 1 to cnMaxRow do
  begin
    sgNums.Cells[0, i] := inttostr(i);
    sgNums.Cells[1, i] := inttostr(RandomRange(100, 1000));
    sgNums.Cells[2, i] := '';
  end;

end;

procedure TFrmMain.FormDestroy(Sender: TObject);
var
  i: integer;
begin

  for i := 0 to 2 do
  begin
    FCountThreadArr[i].Terminate;
    FCountThreadArr[i].WaitFor; // ȴ̴߳˳ execute;
    FCountThreadArr[i].Free;
  end;

end;

procedure TFrmMain.LockCurRow;
begin
  System.TMonitor.Enter(sgNums);
  // dephi °д,൱ٽ, Ϊκһ TOBJECT ʵ
  // ˴ѡ sgNums ҲԶΪ磺FLockCurRow:Tobject,Ȼ Creat ʹá
  // Ա
end;

procedure TFrmMain.LockFininshedCount;
begin
  System.TMonitor.Enter(lblProcess);
end;

procedure TFrmMain.OnCountAction(Sender: TCountThread; ACountAction: TCountAction);
begin
  case ACountAction of
    caNeedANum: DoOnNeedANum(Sender); // ߳һ Num
    caCountResult: DoOnCountResult(Sender); // ̷߳ؽ
    caStop: DoOnStop(Sender); // ֹ߳ͣ
  end;
end;

procedure TFrmMain.OnThreadMsg(AMsg: string);
begin
  // Ϊ vcl Ҫ TThread.Queue ִ
  // Ƿǿص
  TThread.Queue(nil,
    procedure
    begin
      DispMsg(AMsg);
    end);
end;

procedure TFrmMain.UnlockCurRow;
begin
  System.TMonitor.Exit(sgNums);
end;

procedure TFrmMain.UnlockFininshedCount;
begin
  System.TMonitor.Exit(lblProcess);
end;

end.
